<?php

/**
 * Copyright 2007 EDIT GmbH. All rights reserved.
 * Use of this product is subject to license terms.
 */
 
require_once( 'curl_get_cookie.php' );
  
class user_login_hook
{
    var $xtcOptions;
    
    function encodeQueryString($array){
      if(!is_array($array)){
        die("Encode Post Array expects an array");
      }    
      
      $retValue = '';
      for(reset($array);$key=key($array);next($array)){
        $retValue .= $key."=".urlencode($array[$key])."&";
      }
      //zap last &
      $retValue = substr($retValue, 0, -1);      
      return $retValue;
    }
    
    function loadOptions()
    {
        /*$cF = t3lib_div::makeInstance('t3lib_TSparser');
		list($name, $this->xtcOptions) = $cF->getVal('plugin.tx_omxtcuserregister_pi1.login',$GLOBALS['TSFE']->tmpl->setup); */
		$this->xtcOptions = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['edit_xtcuserregister']); 
		if ( !$this->xtcOptions['retryCount'] )
		    $this->xtcOptions['retryCount'] = 5;
    }
    
    function xtcRequest( $do_login, $postfields = array() )
    {
        $XTCCookieName = 'XTCsid';
        $auth_cookie = $_COOKIE[$XTCCookieName];
        if ( !$auth_cookie && !$do_login )
            return;
        
        $ch = curl_init($this->xtcOptions[$do_login ? 'xtcLoginURL' : 'xtcLogoutURL']);
        if ( $this->xtcOptions['saveRequestResult'] )
            $fp = fopen($this->xtcOptions['saveRequestResult'], "w");
    
        $xtc_test_cookie = 'cookie_test=please_accept_for_session';
        if ( $auth_cookie )
            curl_setopt($ch, CURLOPT_COOKIE, $XTCCookieName . '=' . $auth_cookie . '; ' . $xtc_test_cookie );
        else
        {
            InitCurlGetCookie( $ch );
            curl_setopt($ch, CURLOPT_COOKIE, $xtc_test_cookie );
        }
        
        $postfields['Typo3Sync'] = 1;
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $this->encodeQueryString($postfields));
        if ( $fp )
            curl_setopt($ch, CURLOPT_FILE, $fp);
        else
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HEADER, true );
        if ( $do_login )
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']); 
        
        for( $retry = 0; $retry < $this->xtcOptions['retryCount']; ++$retry )
        {
            curl_exec($ch);
            if ( curl_getinfo($ch, CURLINFO_HTTP_CODE) == 200 )
                break;
            sleep( 3 );
        }
        curl_close($ch);
        if ( $fp )
            fclose($fp);
          
        if ( !$auth_cookie && $ret_cookie = CurlGetCookie( $ch, $XTCCookieName ) )
        {          
            setcookie( $XTCCookieName, $ret_cookie, 0, '/' );
            //debug( $ret_cookie );
        }
    }
    
    function login_confirmed($_params, $plugin)
    {
        if ( t3lib_div::GPvar('XTCSync') )
            return;
        $this->loadOptions();
        //debug( $this->xtcOptions );
        if ( !$this->xtcOptions['enabled'] || !$this->xtcOptions['xtcLoginURL'] )
            return;

        if (t3lib_extMgm::isLoaded('kb_md5fepw')) 
        {
            $postfields = array(
                'email_address' => t3lib_div::GPvar('user'),
                'password' => t3lib_div::GPvar('passmd5'),
                'md5' => '1',
            );
        }
        else
        {
            $postfields = array(
                'email_address' => t3lib_div::GPvar('user'),
                'password' => t3lib_div::GPvar('pass'),
                'md5' => '0',
            );
        }

        //debug( $postfields );
        $this->xtcRequest( true, $postfields );
    }
    
    function postUserLookUp($_params, $plugin)
    {
        if ($plugin->loginSessionStarted)
            $this->login_confirmed(null, null);
    }
    
    function logoff_pre_processing($_params, $plugin)
    {
        if ( t3lib_div::GPvar('XTCSync') )
            return;
        $this->loadOptions();
        //debug( $this->xtcOptions );
        if ( !$this->xtcOptions['enabled'] || !$this->xtcOptions['xtcLogoutURL'] )
            return;
        //$username = $plugin->user['username'];
        $this->xtcRequest( false );
    }
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/edit_xtcuserregister/hooks/class.user_login_hook.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/edit_xtcuserregister/hooks/class.user_login_hook.php']);
}

?>