<?php

/**
 * Copyright 2007 EDIT GmbH. All rights reserved.
 * Use of this product is subject to license terms.
 */

class user_re_feregister_hook
{
    var $sendFields;
    var $xtcOptions;
    
    
    function encodeQueryString($array){
      if(!is_array($array)){
        die("Encode Post Array expects an array");
      }    
      
      $retValue = '';
      for(reset($array);$key=key($array);next($array)){
        $retValue .= $key."=".urlencode($array[$key])."&";
      }
      //zap last &
      $retValue = substr($retValue, 0, -1);      
      return $retValue;
    }
    
    
    function xtcRequest( $cmd, $postfields )
    {
        #debug( $postfields, '$postfields' );
        #debug( $this->xtcOptions );
        #debug( $cmd );
        
        $ch = curl_init($this->xtcOptions['xtcWebServiceURL']);
        if ( $this->xtcOptions['saveRequestResult'] )
            $fp = fopen($this->xtcOptions['saveRequestResult'], "w");
    
        $postfields[ 'cmd' ] = $cmd;
            
        curl_setopt($ch, CURLOPT_VERBOSE,true);       
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $this->encodeQueryString($postfields));
        if ( $fp )
            curl_setopt($ch, CURLOPT_FILE, $fp);
        else
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        
        for( $retry = 0; $retry < $this->xtcOptions['retryCount']; ++$retry )
        {
            $response = curl_exec($ch);
            if ( curl_getinfo( $ch, CURLINFO_HTTP_CODE) == 200 )
                break;
            sleep( 3 );
        }
        
        #debug($response);
        curl_close($ch);
        if ( $fp )
            fclose($fp);
    }
    
    function processPostfields( $postfields )
    {
        //debug( $postfields, 'processPostfieldsBefore' );
        $opts = $this->xtcOptions['transformFields.'];
        if ( !$opts )
            return $postfields;
        $local_cObj = t3lib_div::makeInstance( 'tslib_cObj' ); 
        foreach( $postfields as $field => $value )
        {
            if ( $field_opts = $opts[ $field . '.' ] )
            {
                $value = $local_cObj->stdWrap( $value, $field_opts['stdWrap.'] );
                if ( $repl = $field_opts['preg_replace.'] )
                    $value = preg_replace( $repl['pattern'], $repl['replacement'], $value );
                $postfields[ $field ] = $value;
            }
        }
        //debug( $postfields, 'processPostfieldsAfter' );
        return $postfields;
    }

    function extractPostfields( $array )
    {
        $common_fields = array_intersect( array_keys( $array ), $this->sendFields );
        $postfields = array();
        foreach ($common_fields as $f)
            $postfields[ $f ] = $array[ $f ];
        return $this->processPostfields( $postfields );
    }

    function loadOptions( $plugin )
    {
        $this->xtcOptions = $plugin->conf['xtcLink.'];
        //debug( $this->xtcOptions );
        if ( !$this->xtcOptions || !$this->xtcOptions['xtcWebServiceURL'] || !$this->xtcOptions['sendFields'])
            return false;   
        $this->sendFields = t3lib_div::trimExplode( ',', $this->xtcOptions['sendFields'], 1 );
        if ( !$this->xtcOptions['retryCount'] )
            $this->xtcOptions['retryCount'] = 5;
        return true;
    }

    function registrationProcess_afterSaveCreate( $array, $plugin )
    {
        if ( $plugin->webService )
            return;
        //debug( $array, 'registrationProcess_afterSaveCreate' );
        
        if ( !$this->loadOptions( $plugin ) )
            return;
        $this->xtcRequest( 'create', $this->extractPostfields( $array ) );
        //    array_intersect_key( $array, array_flip($this->sendFields) ) ); // PHP bug
    }
    
    /*function registrationProcess_afterSaveEdit( $array, $plugin )
    {
        if ( $plugin->webService )
            return;
        //debug( $array, 'registrationProcess_afterSaveEdit' );
        
        if ( !$this->loadOptions( $plugin ) )
            return;
        $postfields = $this->extractPostfields( $array );
        $postfields['orig_email'] = $plugin->lastAuthArgument['email'];
        $this->xtcRequest( 'modify', $postfields );
    }*/
    
    function confirmRegistrationClass_preProcess( $array, $plugin )
    {
        //debug( $array, 'confirmRegistrationClass_preProcess' );
    }
    
    function confirmRegistrationClass_postProcess( $array, $plugin )
    {
        if ( $plugin->webService )
            return;
        //debug( $array, 'confirmRegistrationClass_postProcess' );
        
        
        if ( !$this->loadOptions( $plugin ) || !$this->xtcOptions['xtcUserGroup'] )
            return false;   
        
        //debug($this->xtcOptions['xtcUserGroupWithVAT']);
        //debug(trim($array['edit_xtcuserregister_vat']));
        
        
        if ($this->xtcOptions['xtcUserGroupWithVAT'] && trim($array['edit_xtcuserregister_vat']) != '' )
        {
	        $postfields = array( 
    	        'email' => $array['email'],
        	    'user_group' => $this->xtcOptions['xtcUserGroupWithVAT'] );
        	//debug($postfields, 'VAT ID is not null and then set VAT Usergroup');    
        }
        else 
        {
	        $postfields = array( 
    	        'email' => $array['email'],
        	    'user_group' => $this->xtcOptions['xtcUserGroup'] );
        	//debug($postfields, 'VAT ID is null and then set standard Usergroup');    
        }
        
        $this->xtcRequest( 'confirm', $postfields );
    }
    
}

function user_registerAfterSave( $content, $conf )
{
    $plugin = $conf['parentObj'];
    if ( $plugin->webService )
        return;
    //debug( $content, 'userFunc_afterSave' );
    $obj = new user_re_feregister_hook;
    if ( !$obj->loadOptions( $plugin ) )
        return;
    $postfields = $obj->extractPostfields( $content['rec'] );
    $postfields['orig_email'] = $content['origRec']['email'];
    $obj->xtcRequest( 'modify', $postfields );
    return $content;
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/edit_xtcuserregister/hooks/class.user_re_feregister_hook.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/edit_xtcuserregister/hooks/class.user_re_feregister_hook.php']);
}

?>