<?php

/***************************************************************
*  Copyright notice
*
*  Copyright 2007 EDIT GmbH. All rights reserved.
*  Use of this product is subject to license terms.
*/

require_once( 't3sync_config.php' );


function encodeQueryString($array){
  if(!is_array($array)){
    die("Encode Post Array expects an array");
  }    
  
  $retValue = '';
  for(reset($array);$key=key($array);next($array)){
    $retValue .= $key."=".urlencode($array[$key])."&";
  }
  //zap last &
  $retValue = substr($retValue, 0, -1);      
  return $retValue;
}

function T3Request( $cmd, $dataconvert, $opts = array() )
{
    global $Typo3RegisterFormURL, $Typo3ModifyRegisterFormURL, $Typo3RegisterSaveRequestResult, $Typo3RegisterRetryCount, $Typo3FEUserPID;
    $Typo3UserRegisterExt = 'edit_xtcuserregister';
    
    $ch = curl_init($cmd == 'create' ? $Typo3RegisterFormURL : $Typo3ModifyRegisterFormURL);
    if ( $Typo3RegisterSaveRequestResult )
        $fp = fopen($Typo3RegisterSaveRequestResult, "w");

    $opts[ 'WebService' ] = 'XTCconnect';
    $opts[ 'Command' ] = $cmd;
    $opts[ 'pid' ] = $Typo3FEUserPID;

    foreach( $dataconvert as $key => $value)
        $postfields[ $Typo3UserRegisterExt.'[fc_users]['.$key.']' ] = $value;
    foreach( $opts as $key => $value)
        $postfields[ $Typo3UserRegisterExt.'['.$key.']' ] = $value;
    
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, encodeQueryString($postfields));
    if ( $fp )
        curl_setopt($ch, CURLOPT_FILE, $fp);
    else
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    
    for( $retry = 0; $retry < $Typo3RegisterRetryCount; ++$retry )
    {
        curl_exec($ch);
        if ( curl_getinfo( $ch, CURLINFO_HTTP_CODE) == 200 )
            break;
        sleep( 1 );
    }
    curl_close($ch);
    if ( $fp )
        fclose($fp);
}

function T3GetCustomerData()
{
    $dob_raw = xtc_date_raw($GLOBALS['dob']);
    $dob_timestamp = 
        substr($dob_raw, 0, 4)
        .'-'.substr($dob_raw, 4, 2)
        .'-'.substr($dob_raw, 6, 2);
    
    $dataconvert = array (
        'username'              => $GLOBALS['email_address'],
	'name'			=> trim($GLOBALS['firstname'] . ' ' . $GLOBALS['lastname']),
        'first_name'            => $GLOBALS['firstname'],
        'last_name'             => $GLOBALS['lastname'],
        'telephone'             => $GLOBALS['telephone'],
        'fax'                   => $GLOBALS['fax'],
        'email'                 => $GLOBALS['email_address'],
        'gender'                => ($GLOBALS['gender'] == 'm' ? 0 : 1),
        'date_of_birth'         => $dob_timestamp,    // year-month-day
        'edit_xtcuserregister_vat' => $GLOBALS['vat'],
    );
    
    return $dataconvert;
}

function T3GetGeoData( $country_id, $zone_id )
{
    $dataconvert = array ();
    $entry_query = xtc_db_query("select countries_iso_code_3 from ".TABLE_COUNTRIES." where countries_id = ".(int) $country_id );

	if (xtc_db_num_rows($entry_query)) 
	{
    	$entry = xtc_db_fetch_array($entry_query);
    	$dataconvert['static_info_country'] = $entry['countries_iso_code_3'];
    	if (ACCOUNT_STATE == 'true' && $zone_id) 
    	{
    	    $entry_query = xtc_db_query("select zone_code from ".TABLE_ZONES." where zone_id = '".(int) $zone_id ."' and zone_country_id=".(int)$country_id );

        	if (xtc_db_num_rows($entry_query)) 
        	{
            	$entry = xtc_db_fetch_array($entry_query);
            	$dataconvert['zone'] = $entry['zone_code'];
            }
        }
    }
    return $dataconvert;
}

function T3CreateAccount()
{
    global $MD5Passwords;
 
    if ($MD5Passwords)
    {
      $set_password = md5($GLOBALS['password']);
    }
    else
    {
      $set_password = $GLOBALS['password'];
    }
  
 
    $dataconvert = array_merge( 
        T3GetCustomerData(),
        T3GetGeoData($GLOBALS['country'], $GLOBALS['zone_id']),
        array (
        'password'              => $set_password,
        'company'               => $GLOBALS['company'],
        'address'               => $GLOBALS['street_address'],
        'city'                  => $GLOBALS['city'],
        'zip'                   => $GLOBALS['postcode'],
        'edit_xtcuserregister_vat' => $GLOBALS['vat'],
        //'language'              => 'EN' // 'DE'
        )
    );
    if (ACCOUNT_SUBURB == 'true') {
	if (trim($GLOBALS['suburb']) != '')
	    $dataconvert['address'] = $GLOBALS['suburb'] . ', '. $dataconvert['address'];
    }
    
    T3Request( 'create', $dataconvert );
    $GLOBALS['skip_create_account_email'] = true;
}

function T3GetCurrentUserName()
{
    $user_query = xtc_db_fetch_array(xtc_db_query("select customers_email_address from ".TABLE_CUSTOMERS." where customers_id = '".(int) $_SESSION['customer_id']."'"));
    return $user_query['customers_email_address'];
}

function T3UpdateAccount( $saved_username )
{
    $dataconvert = T3GetCustomerData();
    $opts = array( 'UserName' => $saved_username );
    T3Request( 'modify', $dataconvert, $opts );
}

function T3UpdateAddress()
{
    $dataconvert = array_merge( 
        T3GetGeoData($GLOBALS['country'], $GLOBALS['zone_id']),
        array (
        'first_name'            => $GLOBALS['firstname'],
        'last_name'             => $GLOBALS['lastname'],
        'zip'                   => $GLOBALS['postcode'],
        'city'                  => $GLOBALS['city'],
        'address'               => $GLOBALS['street_address']
        ) );

	if (ACCOUNT_GENDER == 'true')
	    $dataconvert['gender'] = ($GLOBALS['gender'] == 'm' ? 0 : 1);
	if (ACCOUNT_COMPANY == 'true')
	    $dataconvert['company'] = $GLOBALS['company'];
	if (ACCOUNT_SUBURB == 'true')
	{
		if (trim($GLOBALS['suburb']) != '')
		    $dataconvert['address'] = $GLOBALS['suburb'] . ', '. $dataconvert['address'];
	}
	$opts = array( 'UserName' => T3GetCurrentUserName() );
    T3Request( 'modify', $dataconvert, $opts );
}

function T3UpdatePassword( $password_new, $user_email )
{
    global $MD5Passwords;
 
    if ($MD5Passwords)
    {
      $password_new = md5($password_new);
    }
  
    T3Request( 'modify', 
        array( 'password' => $password_new ),
        array( 'UserName' => $user_email ) 
        );
}

?>